package blackjack;
import java.util.Random;



public class Cards{

	public int deck[] = new int[52];
	public int cardIndex;										// Will keep track of where we are on the deck
	boolean riggedDeck = false;

	// Default constructor
	public Cards(){
		this.cardIndex = 0;
		shuffleDeck();
	}
	
	
	
	// Method to get the next card on top of the deck
	// Automatically shuffles the deck if ran out of cards
	public int getNextCard(){
		int card;
		
		// Find the next non zero card (in case deck got incompletely rigged)
		while(deck[cardIndex] == 0){
			if (cardIndex == 51){
				shuffleDeck();
			}
			cardIndex++;
		}
		
		if (cardIndex == 51)
			shuffleDeck();
		
		card = deck[cardIndex];
		deck[cardIndex++] = 0;
		
		return card;
	}
	
	// Method to rig the deck of cards
	// Returns 0 = success, 1 = bad index, 2 = bad suite, 3 = bad number 
	// Does not check for duplicates
	public int setIndexCard(int card, int Index) {
		// Check index
		if(Index < 0 || Index > 51){
			System.out.println("Invalid index");
			return 1;
		}
		
		if(card/100 < 1 || card/100 > 3){
			System.out.println("Invalid Suite");
			return 2;
		}
		

		if(card%100 < 1 || card%100 > 13){
			System.out.println("Invalid Card #");
			return 3;	
		}
		
		
	    this.deck[Index] = card;
	    return 0;
	}
	
	
	/* Function shuffles the card deck
	 * Cards are identified by suit + number
	 * (H=100, D=200, C=300, S=400)
	 * See: convertCard(int card) for details
	 */
	public void shuffleDeck(){
		Random random = new Random();
		int value;
		int suite;
		boolean alreadyHave = false;
		boolean foundASpot = false;

		
		this.cardIndex = 0;
		
		
		// Run for all 52 cards in the deck
		for(int i = 0; i < 52; i++){
			// Repeat until we find an 'empty' match
			foundASpot = false;
	        while(!foundASpot){
	        	// Pick a card, any card
				value = random.nextInt(13) + 1;					// Random values form 0-12
				suite = random.nextInt(4)*100 + 100;			// Random values from 0-3
				
				// Scan the deck to make sure it hasn't been picked yet
				alreadyHave = false;
				for(int k = 0; k <= i; k++){
					if (this.deck[k] == value + suite){
						alreadyHave = true;
					}
				
					// So if it's a new card value
					if(!alreadyHave){
						this.deck[i] = value + suite;				// Add the card to the deck
						System.out.println(i + "    " + deck[i]);
						foundASpot = true;
						break;						// To exit loop at next iteration
					}
						
				}
	        }// End of while(alreadyHave)
		}// End of the deck
	}// End of shuffleDeck
	

	
	// Converts the card value to a string
	public static String toString(int cardValue){
		String suite = null;
		
		if(cardValue == 0)
			return "Empty";
		// Do a suite check
		switch (cardValue/100) {
        case 1:
        	suite = " of Heart";
        	break;
        case 2:  
        	suite = " of Diamonds";
        	break;
        case 3:  
        	suite = " of Clubs";
        	break;
        case 4:  
        	suite = " of Spades";
        	break;
        default: 
        	suite = ("Invalid Card");
        	break;
		}
		
		// Then output card name & face card if needed
		switch(cardValue%100){
		case 1:
			return ("Ace" + suite);
		case 11:
			return ("Jack" + suite);
		case 12:
			return ("Queen" + suite);
		case 13:
			return ("King" + suite);
		default:
			return (cardValue%100 + suite);
		}
	}
	
	

}
