package blackjack;



public class Dealer{

	// The maximum cards a player can have before busting is 11
	public int hand[] = new int[11];
	public String mainHand;
	public boolean canHit = true;

	
	// Default constructor
	public Dealer(){
	}
	
	
	
	// Method to reset all the cards in hand
	public void resetHand(){
		// 0 used to mark a 'no card' status
		for(int i = 0; i < 11; i++){
			this.hand[i] = 0;
		}
		this.mainHand = "Empty Hand";
		

	}

	
	
	// Method to calculate hand value. 
	// Receives the hand to calculate as a parameter (hand or split)
	public int getHandValue(int handToCalculate[]){
		int score = 0;
		int Aces[] = new int[4];
		int AcesIndex = 0;

		// Aces array is a flag to detect aces in the hand
		// 0 = no aces; 1 = have an ace
		for(int i = 0; i < 3; i++)
			Aces[i] = 0;
		
		// Scan the deck of cards
		for (int i = 0; i < 11; i++){
			// Flag the ace if present
			if(handToCalculate[i]%100 == 1)
				Aces[AcesIndex++] = 1;
			
			if(handToCalculate[i]%100 > 9)
				score += 10;
			else
				score += handToCalculate[i]%100;
		}
		
		// Increment by 10 if have Aces and not bust
		for( ; AcesIndex >= 0; AcesIndex --){
			if((Aces[AcesIndex] == 1) && (score + 10 < 22))
				score += 10;
		}
		return score;
		
		
	}
	
	// Method to 'Hit'
	public void hitHand(int card){

		for(int i = 0; i < 11; i++)
			if (this.hand[i] == 0){
				this.hand[i] = card;
				this.mainHand = stringHand(this.hand);
				return;
			}
	}
	

	
	
	// Converts the card value to a string
	public static String convCardValue(int cardValue){
		String suite = null;
		
		if(cardValue == 0)
			return "Empty";
		// Do a suite check
		switch (cardValue/100) {
        case 1:
        	suite = " of Heart";
        	break;
        case 2:  
        	suite = " of Diamonds";
        	break;
        case 3:  
        	suite = " of Clubs";
        	break;
        case 4:  
        	suite = " of Spades";
        	break;
        default: 
        	suite = ("Invalid Card");
        	break;
		}
		
		// Then output card name & face card if needed
		switch(cardValue%100){
		case 1:
			return ("Ace" + suite);
		case 11:
			return ("Jack" + suite);
		case 12:
			return ("Queen" + suite);
		case 13:
			return ("King" + suite);
		default:
			return (cardValue%100 + suite);
		}
	}

	
	
	// Method to convert the hand in string 
	public String stringHand(int handToConv[]){
		String hand = "";
		String eol = System.getProperty("line.separator");
		
		if(handToConv[0] == 0)
			return "";
		for(int i = 0; i < 11; i++){
			// Break when we hit a null card and export result
			if(handToConv[i] == 0){
				if(getHandValue(handToConv)  == 21 && i == 2){
					hand = hand + "BLACKJACK! (" + getHandValue(handToConv) + ")";		
					break;
				}
				if(getHandValue(handToConv) <= 21){
					hand = hand + "Worth: " + getHandValue(handToConv);		
					break;
				}
				if(getHandValue(handToConv) > 21){
					hand = hand + "BUSTED!! (" + getHandValue(handToConv) + ")";		
					break;
				}
			}
			hand = hand + convCardValue(handToConv[i]) + eol;
			System.out.println(hand);
		}
		
		return hand;
	}

	
}


