package blackjack;

public class HighScoreRecord {
	public int score[] = new int[10];
	public String name[] = new String[10];
	private int scorePtr;
	
	// Default constructor
	public HighScoreRecord(){
		scorePtr = 0;
		for(int i = 0; i < 10; i++){
			score[i] = 0;
			name[i] = "";
		}
	}
	
	// Method to add a new entry in the high score records
	public void insertScore(String newName, int newScore){
		
		int tempScore;
		String tempName;
		
		// If the list isn't full, append it and exit function
		if(scorePtr < 10){
			score[scorePtr] = newScore;
			name[scorePtr++] = newName;
			return;
		}
		
		// Otherwise, check if the new guy can make it on the list
		if(newScore > score[9]){
			score[9] = newScore;
			name[9] = newName;
		}	
		else
			return;
		
		// Finally sort the list
		for(int i = 9; i > 0; i--){
			if(score[i] > score [i - 1]){
				// Record the guy in front of 'i'
				tempName = name[i-1];
				tempScore = score[i-1];
				
				// Bump forward 'i'
				name[i - 1] = name[i];
				score[i - 1] = score[i];
				
				// Bump backwards 'i - 1'
				name[i] = tempName;
				score[i] = tempScore;
			}
		}
	}

	
	// Method that reads high score list and outputs a nice ordered name string
	public String stringNames(){
		
		String eol = System.getProperty("line.separator");	
		String string = "Name";
		
		
		// String the Names
		for(int i = 0; i <= scorePtr; i++){
			
			// Exit when null entry
			if(score[i] == 0)
				return string;
			// Add a new Line
			string = string + eol;
			// Add name
			string = string + name[i];	
		}
		return string;
	}
	
	
	// Method that reads high score list and outputs a nice ordered score string
	public String stringScores(){
		
		String eol = System.getProperty("line.separator");	
		String string = "Score";
		

		// String the Scores
		for(int i = 0; i <= scorePtr; i++){
			
			// Exit when null entry
			if(score[i] == 0)
				return string;
			// Add a new Line
			string = string + eol;
			// Add name
			string = string + "$" + score[i];	
		}
		return string;
	}

}
